<template>
  <div v-if="user" class="user-avatar" :style="styles">
    <div v-if="user.avatar_url">
      <img
        v-if="user.avatar_url.indexOf('http') !== -1"
        :src="user.avatar_url"
      />
      <template v-else>
        <client-only>
          <blur-hash-image
            v-if="user.avatar_blurhash"
            :hash="user.avatar_blurhash"
            :src="`/storage/${user.avatar_url}`"
          />
          <img v-else :src="`/storage/${user.avatar_url}`" />
        </client-only>
      </template>
    </div>
    <span v-if="user.display_name && user.display_name !== null">
      {{ user.display_name.substr(0, 1) }}
    </span>
    <span v-else>{{ user.username.substr(0, 1) }}</span>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, computed } from '@vue/composition-api'
import { UserFragment } from '~/sdk/types'

export default defineComponent({
  name: 'Avatar',
  props: {
    user: { type: Object as PropType<UserFragment>, required: true },
    size: Number || 120
  },
  setup(props) {
    const styles = computed(() => {
      if (props.size) {
        return `width: ${props.size}px; height: ${props.size}px; font-size: ${
          props.size / 2
        }px; backgroundColor: ${stringToColour(props.user.id)}`
      }
    })

    const stringToColour = (str: any) => {
      let hash = 0
      for (var i = 0; i < str.length; i++) {
        hash = str.charCodeAt(i) + ((hash << 5) - hash)
      }
      let colour = '#'
      for (let i = 0; i < 3; i++) {
        let value = (hash >> (i * 8)) & 0xff
        colour += ('00' + value.toString(16)).substr(-2)
      }
      return colour
    }
    return {
      stringToColour,
      styles
    }
  }
})
</script>
<style lang="scss" scoped>
.user-avatar {
  display: inline-flex;
  align-items: center;
  justify-content: center;
  border-radius: 50%;
  font-weight: 500;
  text-transform: uppercase;
  overflow: hidden;
  position: relative;
  color: #fff;
  ::v-deep {
    > div {
      position: absolute !important;
      left: 0px;
      right: 0px;
      top: 0px;
      bottom: 0px;
    }
  }
  img {
    width: 100%;
    height: 100%;
    object-fit: cover;
  }
}
</style>
